package model;

import model.cellule.Cellule;
import model.cellule.observer.ObserverCellule;
import model.cellule.Position;

import java.util.HashMap;

public class CellulesVivantes implements ObserverCellule {
	private HashMap<Position, Cellule> cellVivantes;

	public CellulesVivantes(){
		this(new HashMap<>());
	}

	private CellulesVivantes(HashMap<Position, Cellule> cellVivantes){
		this.cellVivantes = cellVivantes;
	}

	public Cellule getAt(int x, int y){
		Position p = new Position(x, y);
		return cellVivantes.get(p);
	}

	private void addPeer(Cellule cell){	cellVivantes.put(cell.getPosition(), cell);	}

	private void rmPeer(Cellule cellule){
		cellVivantes.remove(cellule.getPosition());
	}

	@Override
	public void update(Cellule cellule) {
		if(cellule.isAlive()){
			addPeer(cellule);
		} else {
			rmPeer(cellule);
		}
	}

	public CellulesVivantes clone(){
		return new CellulesVivantes(new HashMap<>(cellVivantes));
	}

	public void reset(){
		cellVivantes = new HashMap<>();
	}
}
