package model;

import model.actualiseur.ActualiseurCellule;
import model.actualiseur.ActualiseurTour;
import model.actualiseur.ActualiseurTourUnParUn;
import model.boucleDeJeu.BoucleDeJeu5FPS;
import model.boucleDeJeu.IBoucleDeJeu;
import model.boucleDeJeu.observer.ObservableBDJ;
import model.boucleDeJeu.observer.ObserverBDJ;
import model.cellule.Cellule;
import model.plateau.Plateau;

public class Manager implements ObserverBDJ {
	private ActualiseurTour actualiseurTour;
	private ActualiseurCellule actualiseurCellule;
	private IBoucleDeJeu boucleDeJeu;
	private ChangeurRegle changeurRegle;
	private boolean jeuLance;

	public Manager(){
		boucleDeJeu = new BoucleDeJeu5FPS();
		((ObservableBDJ)boucleDeJeu).attacher(this);
		changeurRegle = new ChangeurRegle();
		Thread thread = new Thread(boucleDeJeu);
		thread.start();
		actualiseurCellule = changeurRegle.changerRegle(Regle.CONWAY_STYLE, new Plateau());
		actualiseurTour = new ActualiseurTourUnParUn();
		jeuLance = false;
	}

	@Override
	public void update() {
		if(jeuLance) {
			deleguerChangementCellule();
			actualiseurTour.changerTour();
		}
	}

	public ActualiseurTour getActualiseurTour(){
		return actualiseurTour;
	}

	private void deleguerChangementCellule() {
		CellulesVivantes reference = getActualiseurCellule().getArbitre().getPlateau().getCellulesVivantes().clone();
		for (int y = 0; y<actualiseurCellule.getArbitre().getPlateau().getLigne(); ++y){
			for(int x = 0; x<actualiseurCellule.getArbitre().getPlateau().getColone(); ++x){
				actualiseurCellule.changerCellule(x, y, reference);
			}
		}

	}
	public void inverserEtatCellule(Cellule c){
		getActualiseurCellule().getArbitre().getPlateau().getCell(c.getPosition().getX(), c.getPosition().getY()).inverseAlive();
	}
	public ActualiseurCellule getActualiseurCellule(){
		return actualiseurCellule;
	}

	public void lancerJeu(){
		jeuLance = true;
	}

	public void pauseJeu(){jeuLance = false;}

	public void stoperJeu(){
		actualiseurTour.resetTour();
		actualiseurCellule.getArbitre().getPlateau().getCellulesVivantes().reset();
		jeuLance = false;
	}

	//public void setPlateau(Plateau plateau) {
		//this.plateau = plateau;
	//}
}
