package model.boucleDeJeu.observer;

import javafx.application.Platform;

import java.util.List;

public abstract class ObservableBDJ {
	private List<ObserverBDJ> observeurs;
	protected List<ObserverBDJ> getObserveurs(){
		return observeurs;
	}

	protected void setObserveurs(List<ObserverBDJ> valeur){
		observeurs = valeur;
	}
	public void attacher(ObserverBDJ o) {
		observeurs.add(o);
	}

	public void detacher(Object o) throws IllegalArgumentException{
		if(o.getClass() != ObserverBDJ.class) {
			throw new IllegalArgumentException("Imposible de détacher autre chose qu'un observer");
		}
		observeurs.remove(o);
	}

	public void notifier() {
		for (ObserverBDJ observeur : observeurs) {
			Platform.runLater(()->observeur.update());
		}
	}
}