package model.cellule.observer;

import model.cellule.Cellule;

import java.util.*;

public abstract class ObservableCellule {
	List<ObserverCellule> observeurs;

	public ObservableCellule(){
		observeurs = new LinkedList<>();
	}

	/**
	 *
	 * @param o observeur à attacher
	 * @throws IllegalArgumentException
	 */
	public void attacher(ObserverCellule o) throws  IllegalArgumentException{
		if(o == null){
			throw new IllegalArgumentException("L'observer ne doit pas être null");
		}
		observeurs.add(o);
	}

	/**
	 *
	 * @param o observeur à détacher
	 * @throws IllegalArgumentException
	 */
	public void detacher(ObserverCellule o) throws IllegalArgumentException{
		if(o == null){
			throw new IllegalArgumentException("L'observer ne doit pas être null");
		}
		observeurs.remove(o);
	}

	/**
	 *
	 */
	public void notifier(Cellule cellule) {
		for (ObserverCellule observeur : observeurs) {
			observeur.update(cellule);
		}
	}
}
